'////////////////////////////////////////////////////////////////////////////
' $Workfile: DriveInfo.vbs $ $Revision: 2 $ $Date: 7/04/99 12:33p $
' $Archive: /TimH/Projects (SCC)/Books & Articles/Macmillan/Windows 2000 System Scripting (1999)/Scripts/DriveInfo.vbs $
' Copyright (c) 1999 Tim Hill. All Rights Reserved.
'////////////////////////////////////////////////////////////////////////////

' Display info for specified drive

Option Explicit
Dim sArg, oFSO, sDriveName, sType
Set oFSO = CreateObject("Scripting.FileSystemObject")

' Get absolute path name from command line, then get drive name
If Wscript.Arguments.Count < 1 Then Wscript.Quit(1)
sArg = oFSO.GetAbsolutePathName(Wscript.Arguments(0))
sDriveName = oFSO.GetDriveName(sArg)

' Get drive object and display properties
With oFSO.GetDrive(sDriveName)
    Wscript.Echo "Total size of drive (KB):", .TotalSize / 1024
    Wscript.Echo "Available space (KB)    :", .AvailableSpace / 1024
    Wscript.Echo "Free space (KB)         :", .FreeSpace / 1024
    Wscript.Echo "Drive letter            :", .DriveLetter
    Wscript.Echo "UNC share name          :", .ShareName
    Wscript.Echo "Volume name             :", .VolumeName
    Wscript.Echo "Path                    :", .Path
    Wscript.Echo "Serial number           :", Hex(.SerialNumber)
    Wscript.Echo "File system             :", .FileSystem
    Wscript.Echo "Drive ready             :", CBool(.IsReady)
    Select Case .DriveType
        Case 1: sType = "Removable"
        Case 2: sType = "Fixed"
        Case 3: sType = "Network"
        Case 4: sType = "CDROM"
        Case 5: sType = "RAM Disk"
        Case Else sType = "Unknown"
    End Select
    Wscript.Echo "Drive type              :", sType
End With
Set oFSO = Nothing

'////////////////////////////////////////////////////////////////////////////

