'////////////////////////////////////////////////////////////////////////////
' $Workfile: ShowINFSection.vbs $ $Revision: 1 $ $Date: 7/04/99 3:13p $
' $Archive: /TimH/Projects (SCC)/Books & Articles/Macmillan/Windows 2000 System Scripting (1999)/Scripts/ShowINFSection.vbs $
' Copyright (c) 1999 Tim Hill. All Rights Reserved.
'////////////////////////////////////////////////////////////////////////////

' Uses regular expressions to extract an INF section from an INF file

Option Explicit
Dim sArg, oFSO
Set oFSO = CreateObject("Scripting.FileSystemObject")

' If no arguments, show short usage
If Wscript.Arguments.Count < 2 Then
    Wscript.Echo "usage: showinfsection section-name INF-file"
    Wscript.Quit(0)
End If

' Prepare the regular expression objects
Dim oREStart, oREEnd
Set oREStart = new RegExp
Set oREEnd = new RegExp
oREStart.Pattern = "^\s*\[\s*" & Wscript.Arguments(0) & "\s*\]\s*$"
oREStart.IgnoreCase = True
oREEnd.Pattern = "^\s*\[.*\]\s*$"

' Prepare the input stream
Dim oStream, nState, sLine
Set oStream = oFSO.OpenTextFile(Wscript.Arguments(1))
nState = 0
Do Until oStream.AtEndOfStream
    sLine = oStream.ReadLine
    Select Case nState
        Case 0:     ' State 0: Before section
            If oREStart.Test(sLine) Then nState = 1
        Case 1:     ' State 1: In section
            If oREEnd.Test(sLine) Then
                nState = 2
            Else
                Wscript.Echo sLine
            End If
        Case 2:     ' State 2: After section
    End Select
Loop
Set oStream = Nothing
Set oREStart = Nothing
Set oREEnd = Nothing

'////////////////////////////////////////////////////////////////////////////

