'////////////////////////////////////////////////////////////////////////////
' $Workfile: SplitPath.vbs $ $Revision: 1 $ $Date: 6/23/99 11:15a $
' $Archive: /TimH/Projects (SCC)/Books & Articles/Macmillan/Windows 2000 System Scripting (1999)/Scripts/SplitPath.vbs $
' Copyright (c) 1999 Tim Hill. All Rights Reserved.
'////////////////////////////////////////////////////////////////////////////

' Decompose each argument as a path name

Option Explicit
Dim sArg, oFSO
Set oFSO = CreateObject("Scripting.FileSystemObject")


' Process each argument
For Each sArg In Wscript.Arguments
    ShowComponents sArg, 0
Next

Set oFSO = Nothing

'////////////////////////////////////////////////////////////////////////////
' ShowComponents
' Display individual components from passed path name
'
' sPath             Path name to decompose
' nLevel            Recursion level for indenting
'
Sub ShowComponents(sPath, nLevel)
    Dim sAbsPath, sIndent
    sIndent = Space(nLevel * 4)

    ' Stop recursion when path is empty
    If sPath = "" Then Exit Sub
    
    Wscript.Echo sIndent & "Decompose: " & Chr(34) & sPath & Chr(34)
    sAbsPath = oFSO.GetAbsolutePathName(sPath)
    Wscript.Echo sIndent & "    Absolute path: " & sAbsPath
    Wscript.Echo sIndent & "    Valid file   : " & CBool(oFSO.FileExists(sAbsPath))
    Wscript.Echo sIndent & "    Valid path   : " & CBool(oFSO.FolderExists(sAbsPath))
    Wscript.Echo sIndent & "    File name    : " & oFSO.GetFileName(sAbsPath)
    Wscript.Echo sIndent & "    Base name    : " & oFSO.GetBaseName(sAbsPath)
    Wscript.Echo sIndent & "    Extension    : " & oFSO.GetExtensionName(sAbsPath)
    Wscript.Echo sIndent & "    Drive name   : " & oFSO.GetDriveName(sAbsPath)
    Wscript.Echo
    
    ' Now recursively decompose the parent folder
    ShowComponents oFSO.GetParentFolderName(sAbsPath), nLevel + 1
End Sub

'////////////////////////////////////////////////////////////////////////////

