'////////////////////////////////////////////////////////////////////////////
' $Workfile: VBGrep.vbs $ $Revision: 1 $ $Date: 7/03/99 6:49p $
' $Archive: /TimH/Projects (SCC)/Books & Articles/Macmillan/Windows 2000 System Scripting (1999)/Scripts/VBGrep.vbs $
' Copyright (c) 1999 Tim Hill. All Rights Reserved.
'////////////////////////////////////////////////////////////////////////////

' Uses regular expressions to filter lines in one or more files

Option Explicit
Dim sArg, oFSO
Set oFSO = CreateObject("Scripting.FileSystemObject")

' If no arguments, show short usage
If Wscript.Arguments.Count < 1 Then
    Wscript.Echo "usage: vbgrep reg-exp [folders]"
    Wscript.Echo "If no folders, reads stdin"
    Wscript.Quit(0)
End If

' Prepare the regular expression object
Dim oRE
Set oRE = new RegExp
oRE.Pattern = Wscript.Arguments(0)

' Now process the input
Dim nMatchCount, ix, oFolder, oFile, oStream
nMatchCount = 0
If Wscript.Arguments.Count < 2 Then
    nMatchCount = nMatchCount + GrepStream(Wscript.StdIn, oRE, Wscript.StdOut)
Else
    For ix = 1 To Wscript.Arguments.Count - 1
        sArg = Wscript.Arguments(ix)
        If oFSO.FolderExists(sArg) Then
            Set oFolder = oFSO.GetFolder(sArg)
            For Each oFile In oFolder.Files
                Set oStream = oFile.OpenAsTextStream(1)
                nMatchCount = nMatchCount + GrepStream(oStream, oRE, Wscript.StdOut)
                Set oStream = Nothing
            Next
            Set oFolder = Nothing
        Else
            Wscript.Echo sArg,"not found"
        End If
    Next
End If

Set oRE = Nothing
Set oFSO = Nothing
Wscript.Quit(nMatchCount)

'////////////////////////////////////////////////////////////////////////////
' GrepStream
' Filters a text stream based upon a regular expression object
'
' oStream           Text stream to filter
' oRE               Regular expression for filter
' oOutput           Output stream for results
' Returns           Number of matched lines
'
Function GrepStream(oStream, oRE, oOutput)
    Dim sLine, nCount
    
    'Process each line of input stream
    nCount = 0
    Do Until oStream.AtEndOfStream
        sLine = oStream.ReadLine
        ' If RE match, send line to output stream
        If oRE.Test(sLine) Then
            oOutput.WriteLine sLine
            nCount = nCount + 1
        End If
    Loop
    GrepStream = nCount
End Function

'////////////////////////////////////////////////////////////////////////////

