'////////////////////////////////////////////////////////////////////////////
' $Workfile: VBTree.vbs $ $Revision: 1 $ $Date: 7/03/99 6:49p $
' $Archive: /TimH/Projects (SCC)/Books & Articles/Macmillan/Windows 2000 System Scripting (1999)/Scripts/VBTree.vbs $
' Copyright (c) 1999 Tim Hill. All Rights Reserved.
'////////////////////////////////////////////////////////////////////////////

' Show simple directory tree

Option Explicit
Dim sArg, oFSO
Set oFSO = CreateObject("Scripting.FileSystemObject")

' Get folder (default is current directory)
If Wscript.Arguments.Count > 0 Then
    sArg = Wscript.Arguments(0)
Else
    sArg = "."
End If
sArg = oFSO.GetAbsolutePathName(sArg)

' Process entire tree (if valid folder)
If oFSO.FolderExists(sArg) Then
    Wscript.Echo "Folder tree for:", sArg
    ShowTree "", oFSO.GetFolder(sArg)
End If

Set oFSO = Nothing
Wscript.Quit(0)

'////////////////////////////////////////////////////////////////////////////
' ShowTree
' Show one level of folder tree
'
' sIndent           Indent string
' oFolder           Folder object for this level in tree
'
Sub ShowTree(sIndent, oFolder)
    Dim oSubFolder, ix
    ix = 1
    For Each oSubFolder In oFolder.SubFolders
        Wscript.Echo sIndent & "+--" & oSubFolder.Name
        If ix <> oFolder.SubFolders.Count Then
            ShowTree sIndent & "|  ", oSubFolder
        Else
            ShowTree sIndent & "   ", oSubFolder
        End If
        ix = ix + 1
    Next
End Sub

'////////////////////////////////////////////////////////////////////////////


